//https://raw.githubusercontent.com/simonbarker/pic-libraries/master/onewire.h
#ifndef ONEWIRE_H_   /* Include guard */
#define ONEWIRE_H_

#define _XTAL_FREQ 64000000

//onewirePin defines
#define onewirePin PORTAbits.RA0
#define onewirePinDirection TRISAbits.TRISA0 //0 = output, 1 = input

#define onewirePin1 PORTAbits.RA1
#define onewirePinDirection1 TRISAbits.TRISA1 //0 = output, 1 = input

#define onewirePin2 PORTAbits.RA2
#define onewirePinDirection2 TRISAbits.TRISA2 //0 = output, 1 = input

void onewireWriteBit_X(int b);
void onewireWriteBit_0(int b);
void onewireWriteBit_1(int b) ;
void onewireWriteBit_2(int b) ;

unsigned char onewireReadBit_X();
unsigned char onewireReadBit_0();
unsigned char onewireReadBit_1();
unsigned char onewireReadBit_2();

unsigned char onewireInit_X();
unsigned char onewireInit_0();
unsigned char onewireInit_1();
unsigned char onewireInit_2();

unsigned char onewireReadByte_X();
unsigned char onewireReadByte_0();
unsigned char onewireReadByte_1();
unsigned char onewireReadByte_2();

void onewireWriteByte_X(char data);
void onewireWriteByte_0(char data);
void onewireWriteByte_1(char data);
void onewireWriteByte_2(char data);

unsigned char onewireCRC(unsigned char* addr, unsigned char len);
//void Relecture_Current_ID_datas(void);

#endif